VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "colItem"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private mcolItem As Collection

Private Sub Class_Initialize()

    'instantiate the collection
    Set mcolItem = New Collection
    
End Sub

Private Sub Class_Terminate()

    'destroy the collection
    Set mcolItem = Nothing
    
End Sub

Friend Function Add(ByVal strName As String, _
    ByVal lngAttributes As Long) As clsItem
    
    Dim objNewItem As clsItem
    
    'instantiate a new item
    Set objNewItem = New clsItem

    objNewItem.Name = strName
    objNewItem.Attributes = lngAttributes
    
    mcolItem.Add objNewItem, strName

    'return newly created item
    Set Add = objNewItem
    
    'clean up after ourselves
    Set objNewItem = Nothing

End Function

Friend Sub Clear()

    Dim lngCount As Long
    
    For lngCount = mcolItem.Count To 1 Step -1
        mcolItem.Remove lngCount
    Next lngCount
    
End Sub

Friend Property Get Count() As Long
    Count = mcolItem.Count
End Property

Friend Function nRemove(ByVal lngIndex As Long) As Variant

    If (lngIndex >= 1) And (lngIndex <= mcolItem.Count) Then
    
        mcolItem.Remove lngIndex
        nRemove = 0
    
    Else
        
        'bad return code
        nRemove = -1
    
    End If
    
End Function

Friend Property Get Item(ByVal vntItem As Variant) As clsItem
    Set Item = mcolItem(vntItem)
End Property
