VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ASPFTP"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'used for directory info
Private Const MAX_PATH As Integer = 260
Private Const ERROR_NO_MORE_FILES As Integer = 18

Private Type FILETIME
        dwLowDateTime As Long
        dwHighDateTime As Long
End Type

Private Type WIN32_FIND_DATA
        dwFileAttributes As Long
        ftCreationTime As FILETIME
        ftLastAccessTime As FILETIME
        ftLastWriteTime As FILETIME
        nFileSizeHigh As Long
        nFileSizeLow As Long
        dwReserved0 As Long
        dwReserved1 As Long
        cFileName As String * MAX_PATH
        cAlternate As String * 14
End Type

'collection to hold the directory listing
Private mcolItemList As colItem

'InternetOpen - lAccessType
Private Const INTERNET_OPEN_TYPE_PRECONFIG As Long = 0
Private Const INTERNET_OPEN_TYPE_DIRECT As Long = 1
Private Const INTERNET_OPEN_TYPE_PROXY As Long = 3
'InternetOpen
Private Declare Function InternetOpen Lib "wininet.dll" Alias "InternetOpenA" _
    (ByVal sAgent As String, ByVal lAccessType As Long, ByVal sProxyName As String, _
    ByVal sProxyBypass As String, ByVal lFlags As Long) As Long

'InternetConnect - nServerPort
Private Const INTERNET_INVALID_PORT_NUMBER As Integer = 0
'InternetConnect - lService
Private Const INTERNET_SERVICE_FTP As Long = 1
'InternetConnect - lFlags
Private Const INTERNET_FLAG_PASSIVE As Long = &H8000000
'InternetConnect
Private Declare Function InternetConnect Lib "wininet.dll" Alias "InternetConnectA" _
    (ByVal hInternetSession As Long, ByVal sServerName As String, _
    ByVal nServerPort As Integer, ByVal sUsername As String, _
    ByVal sPassword As String, ByVal lService As Long, _
    ByVal lFlags As Long, ByVal lContext As Long) As Long

'InternetCloseHandle
Private Declare Function InternetCloseHandle Lib "wininet.dll" _
    (ByVal hInet As Long) As Integer

Private Const ERROR_INTERNET_EXTENDED_ERROR As Long = 12003
'InternetGetLastResponseInfo
Private Declare Function InternetGetLastResponseInfo Lib "wininet.dll" Alias "InternetGetLastResponseInfoA" _
    (lpdwError As Long, ByVal lpszBuffer As String, _
    lpdwBufferLength As Long) As Boolean
    
'InternetReadFile
Private Declare Function InternetReadFile Lib "wininet.dll" _
    (ByVal hFile As Long, ByVal lpBuffer As String, _
    ByVal dwNumberOfBytesToRead As Long, _
    lpNumberOfBytesRead As Long) As Boolean

'InternetWriteFile
Private Declare Function InternetWriteFile Lib "wininet.dll" _
    (ByVal hFile As Long, ByVal lpBuffer As String, _
    ByVal dwNumberOfBytesToWrite As Long, _
    lpdwNumberOfBytesWritten As Long) As Boolean

'FtpPutFile/FtpGetFile - dwFlags
Private Const FTP_TRANSFER_TYPE_ASCII As Long = &H1
Private Const FTP_TRANSFER_TYPE_BINARY As Long = &H2

'FtpCreateDirectory
Private Declare Function FtpCreateDirectory Lib "wininet.dll" Alias "FtpCreateDirectoryA" _
    (ByVal hFtpSession As Long, ByVal lpszDirectory As String) As Boolean
    
'FtpDeleteFile
Private Declare Function FtpDeleteFile Lib "wininet.dll" Alias "FtpDeleteFileA" _
    (ByVal hFtpSession As Long, ByVal lpszFileName As String) As Boolean

'FtpFindFirstFile
Private Declare Function FtpFindFirstFile Lib "wininet.dll" Alias "FtpFindFirstFileA" _
    (ByVal hFtpSession As Long, ByVal lpszSearchFile As String, _
    lpFindFileData As WIN32_FIND_DATA, ByVal dwFlags As Long, _
    ByVal dwContent As Long) As Long

'FtpGetCurrentDirectory
Private Declare Function FtpGetCurrentDirectory Lib "wininet.dll" Alias "FtpGetCurrentDirectoryA" _
    (ByVal hFtpSession As Long, ByVal lpszCurrentDirectory As String, _
    lpdwCurrentDirectory As Long) As Boolean

'FtpGetFile
Private Declare Function FtpGetFile Lib "wininet.dll" Alias "FtpGetFileA" _
    (ByVal hFtpSession As Long, ByVal lpszRemoteFile As String, _
    ByVal lpszNewFile As String, ByVal fFailIfExists As Boolean, _
    ByVal dwFlagsAndAttributes As Long, ByVal dwFlags As Long, _
    ByVal dwContext As Long) As Boolean

'FtpOpenFile - lAccess
Private Const GENERIC_READ As Long = &H80000000
Private Const GENERIC_WRITE As Long = &H40000000
'FtpOpenFile
Private Declare Function FtpOpenFile Lib "wininet.dll" Alias "FtpOpenFileA" _
    (ByVal hFtpSession As Long, ByVal sFileName As String, _
    ByVal lAccess As Long, ByVal lFlags As Long, _
    ByVal lContext As Long) As Long

'FtpPutFile
Private Declare Function FtpPutFile Lib "wininet.dll" Alias "FtpPutFileA" _
    (ByVal hFtpSession As Long, ByVal lpszLocalFile As String, _
    ByVal lpszRemoteFile As String, ByVal dwFlags As Long, _
    ByVal dwContext As Long) As Boolean

'FtpRemoveDirectory
Private Declare Function FtpRemoveDirectory Lib "wininet.dll" Alias "FtpRemoveDirectoryA" _
    (ByVal hFtpSession As Long, ByVal lpszDirectory As String) As Boolean

'FtpRenameFile
Private Declare Function FtpRenameFile Lib "wininet.dll" Alias "FtpRenameFileA" _
    (ByVal hFtpSession As Long, ByVal lpszExisting As String, _
    ByVal lpszNew As String) As Boolean

'FtpSetCurrentDirectory
Private Declare Function FtpSetCurrentDirectory Lib "wininet.dll" Alias "FtpSetCurrentDirectoryA" _
    (ByVal hFtpSession As Long, ByVal lpszDirectory As String) As Boolean

'InternetFindNextFile
Private Declare Function InternetFindNextFile Lib "wininet.dll" Alias "InternetFindNextFileA" _
    (ByVal hFind As Long, lpvFindData As WIN32_FIND_DATA) As Long
    
'defaults - InternetOpen
Private Const DEFAULT_AGENT_NAME As String = "NIBLACK FTP DLL"
Private Const DEFAULT_ACCESS_TYPE As Long = INTERNET_OPEN_TYPE_DIRECT

'defaults - InternetConnect
Private Const DEFAULT_USERID As String = "anonymous"
Private Const DEFAULT_PASSIVE_MODE As Boolean = True

'defaults - FtpGetFile/FtpPutFile
Private Const DEFAULT_TRANSFER_TYPE As Long = FTP_TRANSFER_TYPE_ASCII
Private Const DEFAULT_OVER_WRITE As Integer = 0

'defaults - FtpOpenFile
Private Const DEFAULT_FILE_ACCESS As Long = GENERIC_WRITE

'class vars
Private mlngErrorNum As Long            'error number
Private mstrErrorDesc As String         'error message

'class vars - InternetOpen
Private mstrAgentName As String         'agent name
Private mlngAccessType As Long          'access type
Private mstrProxyName As String         'proxy name
Private mstrProxyBypass As String       'proxy bypass info
Private mlngINet As Long                'handle from InternetOpen

'class vars - InternetConnect
Private mstrServerName As String        'ftp server name - dns/ip
Private mstrUserID As String            'user id
Private mstrPassword As String          'password
Private mblnPassiveMode As Boolean      'passive ftp syntax?
Private mlngINetConn As Long            'handle from InternetConnect

'class vars - FtpOpenFile/InternetReadFile/InternetWriteFile
Private mlngINetConnFTP As Long         'handle from FtpOpenFile
Private mlngFileAccess As Long          'read or write flag for file

'class vars - FtpGetFile/FtpPutFile
Private mlngTransferType As Long        'trasfer type - ascii/binary
Private mintOverWrite As Integer        'overwrite existing file on get

Private Function bEnumDir(Optional ByVal strDir As String) As Boolean

    Dim pData As WIN32_FIND_DATA
    Dim lngHINet As Long
    Dim intError As Integer
    Dim strTemp As String
    Dim blnRC As Boolean
    Dim blnDir As Boolean
    
    'i'm optimistic
    bEnumDir = True
    
    'clear any existing items
    mcolItemList.Clear
        
    'was a directory specfied?
    If Len(strDir) > 0 Then
        
        'move to the correct directory
        blnDir = bSetCurrentDir(strDir)
    
    Else
    
        'spoof rc
        blnDir = True
        
    End If
    
    If blnDir Then
    
        'init the filename buffer
        pData.cFileName = String(MAX_PATH, 0)
        
        'get the first file in the directory...
        lngHINet = FtpFindFirstFile(mlngINetConn, "*.*", pData, 0, 0)
        
        'how'd we do?
        If lngHINet = 0 Then
            'get the error from the findfirst call
            intError = Err.LastDllError
            
            'is the directory empty?
            If intError <> ERROR_NO_MORE_FILES Then
                'whoa...a real error
                ErrorUpd intError, Err.Description
                
                'set bad return code
                bEnumDir = False
            End If
            
        Else
            
            'we got some dir info...
            'get the name
            strTemp = Left(pData.cFileName, InStr(1, pData.cFileName, String(1, 0), vbBinaryCompare) - 1)
            'store the item
            mcolItemList.Add strTemp, pData.dwFileAttributes
                    
            'now loop through the rest of the files...
            Do
                'init the filename buffer
                pData.cFileName = String(MAX_PATH, 0)
                
                'get the next item
                blnRC = InternetFindNextFile(lngHINet, pData)
                
                'how'd we do?
                If Not blnRC Then
                
                    'get the error from the findnext call
                    intError = Err.LastDllError
                    
                    'no more items
                    If intError <> ERROR_NO_MORE_FILES Then
                        'whoa...a real error
                        ErrorUpd intError, Err.Description
                        
                        'set bad return code
                        bEnumDir = False
                        
                        Exit Do
                    
                    Else
                        
                        'no more items...
                        Exit Do
                        
                    End If
                    
                Else
                    
                    'get the name
                    strTemp = Left(pData.cFileName, InStr(1, pData.cFileName, String(1, 0), vbBinaryCompare) - 1)
                    'store the item
                    mcolItemList.Add strTemp, pData.dwFileAttributes
                                
                End If
                
            Loop
            
            'close the handle for the dir listing
            InternetCloseHandle lngHINet
            
        End If
    End If
End Function


Public Function bQGetFile(ByVal strServerName As String, ByVal strUserID As String, _
    ByVal strPassword As String, ByVal strSourceFile As String, _
    ByVal strTargetFile As String, ByVal lngTransferType As Long, _
    ByVal blnOverWrite As Boolean) As Variant

    Dim blnRC As Boolean
    
    'init the return code...i'm very optimistic
    bQGetFile = True
    
    'clean any old errors
    ErrorClear
    
    'kill any exisiting connections
    bDisconnect
    
    'set properties w/user's settings
    sServerName = strServerName
    sUserID = strUserID
    sPassword = strPassword
    lTransferType = lngTransferType
    bOverWrite = blnOverWrite
               
    'get a connection
    If bConnect Then
        
        'put it!
        blnRC = FtpGetFile(mlngINetConn, strSourceFile, _
            strTargetFile, mintOverWrite, 0, mlngTransferType, 0)
            
        'how'd we do?
        If blnRC = False Then
            
            'whoa...something happened
            ErrorUpd Err.Number, Err.Description
            bQGetFile = False
        
        Else
            
            'we done good!
            bQGetFile = True
        
        End If
        
    Else
        
        'setup error stuff
        mlngErrorNum = -1
        mstrErrorDesc = "Could not connect to server."
        
        'send bad return code
        bQGetFile = False
        
    End If
    
    'clean up any handles
    bDisconnect

End Function

Public Function bQPutFile(ByVal strServerName As String, ByVal strUserID As String, _
    ByVal strPassword As String, ByVal strSourceFile As String, _
    ByVal strTargetFile As String, ByVal lngTransferType As Long) As Variant
                
    Dim blnRC As Boolean
    
    'init the return code...i'm very optimistic
    bQPutFile = True
    
    'clean any old errors
    ErrorClear
    
    'kill any exisiting connections
    bDisconnect
    
    'set properties w/user's settings
    sServerName = strServerName
    sUserID = strUserID
    sPassword = strPassword
    lTransferType = lngTransferType
               
    'get a connection
    If bConnect Then
    
        'put it!
        blnRC = FtpPutFile(mlngINetConn, strSourceFile, _
            strTargetFile, mlngTransferType, 0)
            
        'how'd we do?
        If blnRC = False Then
            
            'whoa...something happened
            ErrorUpd Err.Number, Err.Description
            bQPutFile = False
        
        Else
            
            'we done good!
            bQPutFile = True
        
        End If
        
    Else
        
        'setup error stuff
        mlngErrorNum = -1
        mstrErrorDesc = "Could not connect to server."
        
        'send bad return code
        bQPutFile = False
        
    End If
    
    'clean up any handles
    bDisconnect

End Function

Public Function sGetDirName(ByVal intItem As Integer) As Variant

    'clear any existing errors
    ErrorClear

    'make sure the index is within our collection
    If (intItem >= 1) And (intItem <= mcolItemList.Count) Then
    
        'send back the name
        sGetDirName = mcolItemList.Item(intItem).Name
        
    Else
        
        'send back error
        mlngErrorNum = -1
        mstrErrorDesc = "Index out of range."
        sGetDirName = ""
        
    End If
    
End Function

Public Function lGetDirCount() As Variant

    'clear any existing errors
    ErrorClear

    lGetDirCount = mcolItemList.Count
    
End Function

Public Function bGetDir(Optional ByVal strDir As String, _
    Optional ByVal intType As Integer) As Variant
    
    Dim lngEntries As Long
    Dim lngX As Long
    Dim blnRC As Boolean
    
    'clean up any old errors
    ErrorClear
    
    'I'm optimistic
    bGetDir = True
    
    'enumerate the directory listing
    If Len(strDir) > 0 Then
        
        'get specified directories contents
        blnRC = bEnumDir(strDir)
        
    Else
    
        'get default directories contents
        blnRC = bEnumDir
    
    End If
    
    If blnRC Then
                
        'get the number of entries in the dir listing
        lngEntries = mcolItemList.Count
    
        'do we have any?
        If lngEntries > 0 Then
        
            'yep...
            
            'work through all the entries
            For lngX = lngEntries To 1 Step -1
                
                'type flags?
                If intType > 0 Then
                
                    'remove item if it doesn't match
                    If Not (mcolItemList.Item(lngX).Attributes And intType) = intType Then
                        mcolItemList.nRemove lngX
                    End If
                    
                End If
                                
            Next
            
            'check for no entries matching
            If mcolItemList.Count = 0 Then
                mlngErrorNum = 0
                mstrErrorDesc = "No Matching Entries"
                bGetDir = True
            End If
            
        Else
            
            'no entries...send back empty string
            mlngErrorNum = 0
            mstrErrorDesc = "Empty Directory"
            bGetDir = True
            
        End If
                    
    Else
    
        'send back bad return code
        bGetDir = False
    
    End If
    
End Function

Public Function sListDir(Optional ByVal strDir As String, _
    Optional ByVal intType As Integer) As Variant

    Dim lngEntries As Long
    Dim lngX As Long
    Dim strTemp As String
    Dim blnRC As Boolean
    
    'clean up any old errors
    ErrorClear
    
    'init return...send back empty string
    sListDir = ""
    
    'enumerate the directory listing
    If Len(strDir) > 0 Then
        
        'get specified directories contents
        blnRC = bEnumDir(strDir)
        
    Else
    
        'get default directories contents
        blnRC = bEnumDir
    
    End If
    
    If blnRC Then
    
        'get the number of entries in the dir listing
        lngEntries = mcolItemList.Count
    
        'do we have any?
        If lngEntries > 0 Then
        
            'yep...list 'em
            
            'init return string
            sListDir = ""
            
            'work through all the entries
            For lngX = 1 To lngEntries
                
                'init temp string
                strTemp = ""
                
                'get the name, if it matches
                If intType > 0 Then
                    If mcolItemList.Item(lngX).Attributes And intType Then
                        strTemp = mcolItemList.Item(lngX).Name
                    End If
                Else
                    strTemp = mcolItemList.Item(lngX).Name
                End If
                
                'did we find a match?
                If strTemp <> "" Then
                    
                    'add to the return string
                    If sListDir = "" Then
                        sListDir = strTemp
                    Else
                        sListDir = sListDir & ";" & strTemp
                    End If
                    
                End If
                
            Next
            
            'check for no entries matching
            If sListDir = "" Then
                mlngErrorNum = 0
                mstrErrorDesc = "No Matching Entries"
            End If
            
        Else
            
            'no entries...send back empty string
            mlngErrorNum = 0
            mstrErrorDesc = "Empty Directory"
            sListDir = ""
            
        End If
    
    End If
    
End Function

Private Sub Class_Initialize()
    
    'setup default class vars for this instance
    
    'InternetOpen
    mstrAgentName = DEFAULT_AGENT_NAME
    mlngAccessType = DEFAULT_ACCESS_TYPE
    mstrProxyName = ""
    mstrProxyBypass = ""
    mlngINet = 0

    'InternetConnect
    mstrServerName = ""
    mstrUserID = DEFAULT_USERID
    mstrPassword = ""
    mblnPassiveMode = DEFAULT_PASSIVE_MODE
    mlngINetConn = 0

    'FtpGetFile/FtpPutFile
    mlngTransferType = DEFAULT_TRANSFER_TYPE
    mintOverWrite = DEFAULT_OVER_WRITE
    
    'FtpOpenFile
    mlngFileAccess = DEFAULT_FILE_ACCESS
    mlngINetConnFTP = 0
    
    'error stuff
    mlngErrorNum = 0
    mstrErrorDesc = ""
    
    'listing stuff
    Set mcolItemList = New colItem
    
End Sub


Private Sub Class_Terminate()
        
    'clean up after ourselves...incase the user didn't
    bDisconnect
    
    'clear the item collection
    Set mcolItemList = Nothing
    
End Sub
Public Function bDisconnect() As Variant
        
    'open file?
    If mlngINetConnFTP <> 0 Then
        InternetCloseHandle mlngINetConnFTP
        mlngINetConnFTP = 0
    End If
    
    'active connection handle?
    If mlngINetConn <> 0 Then
        InternetCloseHandle mlngINetConn
        mlngINetConn = 0
    End If
    
    'active open handle?
    If mlngINet <> 0 Then
        InternetCloseHandle mlngINet
        mlngINet = 0
    End If
    
    'clear any item list
    mcolItemList.Clear
    
    bDisconnect = True
End Function

Public Property Get lFileAccess() As Variant
    If mlngFileAccess = GENERIC_WRITE Then
        lFileAccess = 1
    Else
        lFileAccess = 2
    End If
End Property

Public Property Let lFileAccess(ByVal lngFileAccess As Variant)
    If lngFileAccess = 1 Then
        mlngFileAccess = GENERIC_WRITE
    Else
        mlngFileAccess = GENERIC_READ
    End If
End Property

Public Property Get lAccessType() As Variant
    lAccessType = mlngAccessType
End Property

Public Property Let lAccessType(ByVal lngAccessType As Variant)
    mlngAccessType = lngAccessType
End Property

Public Property Get sProxyName() As Variant
    sProxyName = mstrProxyName
End Property

Public Property Let sProxyName(ByVal strProxyName As Variant)
    mstrProxyName = Trim(strProxyName)
End Property

Public Property Get sProxyBypass() As Variant
    sProxyBypass = mstrProxyBypass
End Property

Public Property Let sProxyBypass(ByVal strProxyBypass As Variant)
    mstrProxyBypass = Trim(strProxyBypass)
End Property

Public Property Get sError() As Variant
    sError = mlngErrorNum & ": " & mstrErrorDesc
End Property

Public Property Get lErrorNum() As Variant
    lErrorNum = mlngErrorNum
End Property

Public Property Get sErrorDesc() As Variant
    sErrorDesc = mstrErrorDesc
End Property

Public Property Get sServerName() As Variant
    sServerName = mstrServerName
End Property

Public Property Let sServerName(ByVal strServerName As Variant)
    mstrServerName = Trim(strServerName)
End Property

Public Property Get sUserID() As Variant
    sUserID = mstrUserID
End Property

Public Property Let sUserID(ByVal strUserID As Variant)
    mstrUserID = Trim(strUserID)
End Property

Public Property Get sPassword() As Variant
    sPassword = mstrPassword
End Property

Public Property Let sPassword(ByVal strPassword As Variant)
    mstrPassword = Trim(strPassword)
End Property

Public Property Get bPassiveMode() As Variant
    bPassiveMode = mblnPassiveMode
End Property

Public Property Let bPassiveMode(ByVal blnPassiveMode As Variant)
    mblnPassiveMode = blnPassiveMode
End Property

Public Property Get bOverWrite() As Variant
    If mintOverWrite = 0 Then
        bOverWrite = True
    Else
        bOverWrite = False
    End If
End Property

Public Property Let bOverWrite(ByVal blnOverWrite As Variant)
    If blnOverWrite Then
        mintOverWrite = 0
    Else
        mintOverWrite = -1
    End If
End Property

Public Property Get lTransferType() As Variant
    lTransferType = mlngTransferType
End Property

Public Property Let lTransferType(ByVal lngTransferType As Variant)
    mlngTransferType = lngTransferType
End Property

Public Function bCloseFile() As Variant

    'clear any errors
    ErrorClear

    'open file?
    If mlngINetConnFTP <> 0 Then
        InternetCloseHandle mlngINetConnFTP
        mlngINetConnFTP = 0
    End If
    
    bCloseFile = True
    
End Function

Public Function sConvertCrLf(ByVal strData As String) As Variant

    Dim lngLoc As Long
    Dim strTemp As String
    
    'init the return string
    strTemp = ""
    
    Do
        'get location of crlf
        lngLoc = InStr(strData, vbCrLf)
        
        'did we find it?
        If lngLoc > 0 Then
            
            'convert crlf to html br tag
            strTemp = strTemp & Left(strData, lngLoc) & "<br>"
            
            'reset string
            strData = Mid(strData, lngLoc + 2)
            
        Else
            
            'wasn't found...just add rest of string
            strTemp = strTemp & strData
            
            'end looping
            Exit Do
            
        End If
        
    Loop
    
    'send back converted string
    sConvertCrLf = strTemp
    
End Function

Public Function sReadFile() As Variant

    Dim blnRC As Boolean
    Dim lngBytes As Long
    Dim strTemp As String
    Dim strBuffer As String
    
    'clean up any old errors
    ErrorClear
    
    'make sure we have an open file
    If mlngINetConnFTP <> 0 Then
    
        'init temp string
        strTemp = ""
    
        'loop through the entire file
        Do
            
            'init the data buffer
            strBuffer = String(1024, 0)
        
            'read upto 1024 bytes of data...
            blnRC = InternetReadFile(mlngINetConnFTP, strBuffer, _
                1024, lngBytes)
            
            'how'd we do?
            If blnRC Then
            
                'done good...save the data
                strTemp = strTemp & Left(strBuffer, lngBytes)
            
                'check eof (lngBytes = 0)
                If lngBytes = 0 Then
                    
                    'file's complete...send back the data
                    sReadFile = strTemp
                    
                    Exit Do
                    
                End If
            
            Else
            
                'send back error
                ErrorUpd Err.LastDllError, Err.Description
                sReadFile = ""
                
                Exit Do
            
            End If
            
        Loop
        
    Else
    
        'send back error
        mlngErrorNum = -1
        mstrErrorDesc = "No File Opened."
        sReadFile = ""
    
    End If

End Function

Public Function bWriteFile(ByVal strData As String) As Variant

    Dim blnRC As Boolean
    Dim lngBytes As Long
    
    'clean up any old errors
    ErrorClear
    
    'make sure we have an open file
    If mlngINetConnFTP <> 0 Then
    
        'write the data to the file
        blnRC = InternetWriteFile(mlngINetConnFTP, strData, _
            Len(strData), lngBytes)
        
        'how'd we do?
        If blnRC Then
        
            'check to make sure the number of bytes written match
            If lngBytes = Len(strData) Then
                
                'done good!
                bWriteFile = True
                
            Else
            
                'send back error
                ErrorUpd Err.LastDllError, Err.Description
                bWriteFile = False
            
            End If
        
        Else
        
            'send back error
            ErrorUpd Err.LastDllError, Err.Description
            bWriteFile = False
        
        End If
        
    Else
    
        'send back error
        mlngErrorNum = -1
        mstrErrorDesc = "No File Opened."
        bWriteFile = False
    
    End If
    
End Function

Public Function bOpenFile(ByVal strFileName As String) As Variant

    Dim blnRC As Boolean
    Dim lConnRC As Long
    
    'clean up any old errors
    ErrorClear
    
    'I'm optimistic
    bOpenFile = True
                    
    'make sure we have a connection
    If mlngINetConn = 0 Then
    
        'whoa...we need a connection first
        bConnect
        
    End If
        
    'we better have a connection now
    If mlngINetConn <> 0 Then
        
        'open the file
        mlngINetConnFTP = FtpOpenFile(mlngINetConn, strFileName, _
            mlngFileAccess, mlngTransferType, 0)
            
        'how'd we do?
        If mlngINetConnFTP = 0 Then
            
            'whoa...something happened
            ErrorUpd Err.LastDllError, Err.Description
            bOpenFile = False
        
        Else
            
            'we done good!
            bOpenFile = True
        
        End If
    Else
        
        'send back error
        mlngErrorNum = -1
        mstrErrorDesc = "Could not connect to server."
        bOpenFile = False
        
    End If
    
End Function

Public Function bConnect() As Variant
    
    Dim lngFlags As Long

    'clean up any old errors
    ErrorClear

    'do we have an open handle...just a safeguard for the users?
    If mlngINet = 0 Then
        'get new open handle based on proxy info
        If mlngAccessType <> INTERNET_OPEN_TYPE_DIRECT Then
            'use proxy info
            mlngINet = InternetOpen(mstrAgentName, mlngAccessType, _
                mstrProxyName, mstrProxyBypass, 0)
        Else
            'direct...
            mlngINet = InternetOpen(mstrAgentName, _
                INTERNET_OPEN_TYPE_DIRECT, vbNullString, _
                vbNullString, 0)
        End If
    End If
    
    'check for an open handle again...
    If mlngINet <> 0 Then
        'we have a open handle...now get a connection handle
        
        'do we already have a connection handle?
        If mlngINetConn <> 0 Then
            
            'connection exists...good return code
            bConnect = True
        
        Else
        
            If mstrServerName = "" Then
                'can't work without a server name...
                mstrErrorDesc = "Server name required."
                mlngErrorNum = -1

                'clean up handles
                bDisconnect
                
                'set bad return code
                bConnect = False
                
            Else

                'are we in passive mode?
                If mblnPassiveMode Then
                    lngFlags = INTERNET_FLAG_PASSIVE
                Else
                    lngFlags = 0
                End If
                
                'get connection
                mlngINetConn = InternetConnect(mlngINet, mstrServerName, _
                    INTERNET_INVALID_PORT_NUMBER, mstrUserID, mstrPassword, _
                    INTERNET_SERVICE_FTP, lngFlags, 0)
                
                'did we get a connection?
                If mlngINetConn <> 0 Then
                
                    'pass back good return code
                    bConnect = True
                    
                Else
                
                    'whoa nellie...something bad happened
                    ErrorUpd Err.LastDllError, Err.Description
                    bConnect = False
                    
                End If
            End If
        End If
    Else
    
        'couldn't get a open handle
        ErrorUpd Err.LastDllError, Err.Description
        bConnect = False
        
    End If
    
End Function

Public Function bRename(ByVal strCurrentName As String, _
    ByVal strNewName As String) As Variant
    
    Dim blnRC As Boolean
    Dim lConnRC As Long
    
    'clean up any old errors
    ErrorClear
            
    'make sure we have a connection
    If mlngINetConn = 0 Then
    
        'whoa...we need a connection first
        bConnect
        
    End If
        
    'we better have a connection now
    If mlngINetConn <> 0 Then
        'put it!
        blnRC = FtpRenameFile(mlngINetConn, strCurrentName, _
            strNewName)
            
        'how'd we do?
        If blnRC = False Then
            
            'whoa...something happened
            ErrorUpd Err.LastDllError, Err.Description
            bRename = False
        
        Else
            
            'we done good!
            bRename = True
        
        End If
    Else
        
        'send back error
        mlngErrorNum = -1
        mstrErrorDesc = "Could not connect to server."
        bRename = False
        
    End If
    
End Function

Public Function bGetFile(ByVal strSourceFile As String, _
    ByVal strTargetFile As String) As Variant
    
    Dim blnRC As Boolean
    Dim lConnRC As Long
    
    'clean up any old errors
    ErrorClear
            
    'make sure we have a connection
    If mlngINetConn = 0 Then
    
        'whoa...we need a connection first
        bConnect
        
    End If
        
    'we better have a connection now
    If mlngINetConn <> 0 Then
        'put it!
        blnRC = FtpGetFile(mlngINetConn, strSourceFile, _
            strTargetFile, mintOverWrite, 0, mlngTransferType, 0)
            
        'how'd we do?
        If blnRC = False Then
            
            'whoa...something happened
            ErrorUpd Err.LastDllError, Err.Description
            bGetFile = False
        
        Else
            
            'we done good!
            bGetFile = True
        
        End If
    Else
        
        'send back error
        mlngErrorNum = -1
        mstrErrorDesc = "Could not connect to server."
        bGetFile = False
        
    End If
    
End Function

Public Function bPutFile(ByVal strSourceFile As String, _
    ByVal strTargetFile As String) As Variant
    
    Dim blnRC As Boolean
    Dim lConnRC As Long
    
    'clean up any old errors
    ErrorClear
            
    'make sure we have a connection
    If mlngINetConn = 0 Then
    
        'whoa...we need a connection first
        bConnect
        
    End If
        
    'we better have a connection now
    If mlngINetConn <> 0 Then
        'put it!
        blnRC = FtpPutFile(mlngINetConn, strSourceFile, _
            strTargetFile, mlngTransferType, 0)
            
        'how'd we do?
        If blnRC = False Then
            
            'whoa...something happened
            ErrorUpd Err.LastDllError, Err.Description
            bPutFile = False
        
        Else
            
            'we done good!
            bPutFile = True
        
        End If
    Else
        
        'send back error
        mlngErrorNum = -1
        mstrErrorDesc = "Could not connect to server."
        bPutFile = False
        
    End If
    
End Function

Public Function bQRemoveDir(ByVal strServerName As String, ByVal strUserID As String, _
    ByVal strPassword As String, ByVal strDir As String) As Variant
    
    Dim blnRC As Boolean
    Dim lConnRC As Long
    
    'init the return code...i'm very optimistic
    bQRemoveDir = True
    
    'clean up any old errors
    ErrorClear
    
    'kill any exisiting connections
    bDisconnect
    
    'set properties w/user's settings
    sServerName = strServerName
    sUserID = strUserID
    sPassword = strPassword
               
    'get a connection
    If bConnect Then
            
        'delete the file
        blnRC = FtpRemoveDirectory(mlngINetConn, strDir)
        
        'how'd we do?
        If blnRC Then
        
            'send back good return code
            bQRemoveDir = True
            
        Else
            
            'send back the error
            bQRemoveDir = False
            ErrorUpd Err.LastDllError, Err.Description
            
        End If
        
    Else
    
        'whoa...we don't have a connection
        mlngErrorNum = -1
        mstrErrorDesc = "Could not connect to server."
        bQRemoveDir = False
        
    End If
    
    'clean up any handles
    bDisconnect
    
End Function

Public Function bQMakeDir(ByVal strServerName As String, ByVal strUserID As String, _
    ByVal strPassword As String, ByVal strDir As String) As Variant

    Dim blnRC As Boolean
    Dim lConnRC As Long
    
    'init the return code...i'm very optimistic
    bQMakeDir = True
    
    'clean up any old errors
    ErrorClear
    
    'kill any exisiting connections
    bDisconnect
    
    'set properties w/user's settings
    sServerName = strServerName
    sUserID = strUserID
    sPassword = strPassword
               
    'get a connection
    If bConnect Then
            
        'delete the file
        blnRC = FtpCreateDirectory(mlngINetConn, strDir)
        
        'how'd we do?
        If blnRC Then
        
            'send back good return code
            bQMakeDir = True
            
        Else
            
            'send back the error
            bQMakeDir = False
            ErrorUpd Err.LastDllError, Err.Description
            
        End If
        
    Else
    
        'whoa...we don't have a connection
        mlngErrorNum = -1
        mstrErrorDesc = "Could not connect to server."
        bQMakeDir = False
        
    End If
    
    'clean up any handles
    bDisconnect

End Function

Public Function bQRename(ByVal strServerName As String, ByVal strUserID As String, _
    ByVal strPassword As String, ByVal strCurrentName As String, _
    ByVal strNewName As String) As Variant
    
    Dim blnRC As Boolean
    Dim lConnRC As Long
    
    'init the return code...i'm very optimistic
    bQRename = True
    
    'clean up any old errors
    ErrorClear
    
    'kill any exisiting connections
    bDisconnect
    
    'set properties w/user's settings
    sServerName = strServerName
    sUserID = strUserID
    sPassword = strPassword
               
    'get a connection
    If bConnect Then
            
        'delete the file
        blnRC = FtpRenameFile(mlngINetConn, strCurrentName, _
            strNewName)
        
        'how'd we do?
        If blnRC Then
        
            'send back good return code
            bQRename = True
            
        Else
            
            'send back the error
            bQRename = False
            ErrorUpd Err.LastDllError, Err.Description
            
        End If
        
    Else
    
        'whoa...we don't have a connection
        mlngErrorNum = -1
        mstrErrorDesc = "Could not connect to server."
        bQRename = False
        
    End If
    
    'clean up any handles
    bDisconnect
    
End Function

Public Function bQDeleteFile(ByVal strServerName As String, ByVal strUserID As String, _
    ByVal strPassword As String, ByVal strFile As String) As Variant
    
    Dim blnRC As Boolean
    Dim lConnRC As Long
    
    'init the return code...i'm very optimistic
    bQDeleteFile = True
    
    'clean up any old errors
    ErrorClear
    
    'kill any exisiting connections
    bDisconnect
    
    'set properties w/user's settings
    sServerName = strServerName
    sUserID = strUserID
    sPassword = strPassword
               
    'get a connection
    If bConnect Then
    
        'delete the file
        blnRC = FtpDeleteFile(mlngINetConn, strFile)
        
        'how'd we do?
        If blnRC Then
        
            'send back good return code
            bQDeleteFile = True
            
        Else
            
            'send back the error
            bQDeleteFile = False
            ErrorUpd Err.LastDllError, Err.Description
            
        End If
        
    Else
    
        'whoa...we don't have a connection
        mlngErrorNum = -1
        mstrErrorDesc = "Could not connect to server."
        bQDeleteFile = False
        
    End If
    
    'clean up any handles
    bDisconnect

End Function

Public Function bRemoveDir(ByVal strDir As String) As Variant

    Dim blnRC As Boolean
    
    'clean up any old errors
    ErrorClear
    
    'make sure we have a connection
    If mlngINetConn <> 0 Then
        
        'delete the file
        blnRC = FtpRemoveDirectory(mlngINetConn, strDir)
        
        'how'd we do?
        If blnRC Then
        
            'send back good return code
            bRemoveDir = True
            
        Else
            
            'send back the error
            bRemoveDir = False
            ErrorUpd Err.LastDllError, Err.Description
            
        End If
        
    Else
    
        'whoa...we don't have a connection
        mlngErrorNum = -1
        mstrErrorDesc = "No available connection."
        bRemoveDir = False
        
    End If

End Function

Public Function bMakeDir(ByVal strDir As String) As Variant

    Dim blnRC As Boolean
    
    'clean up any old errors
    ErrorClear
    
    'make sure we have a connection
    If mlngINetConn <> 0 Then
        
        'delete the file
        blnRC = FtpCreateDirectory(mlngINetConn, strDir)
        
        'how'd we do?
        If blnRC Then
        
            'send back good return code
            bMakeDir = True
            
        Else
            
            'send back the error
            bMakeDir = False
            ErrorUpd Err.LastDllError, Err.Description
            
        End If
        
    Else
    
        'whoa...we don't have a connection
        mlngErrorNum = -1
        mstrErrorDesc = "No available connection."
        bMakeDir = False
        
    End If

End Function

Public Function bDeleteFile(ByVal strFile As String) As Variant
    
    Dim blnRC As Boolean
    
    'clean up any old errors
    ErrorClear
    
    'make sure we have a connection
    If mlngINetConn <> 0 Then
        
        'delete the file
        blnRC = FtpDeleteFile(mlngINetConn, strFile)
        
        'how'd we do?
        If blnRC Then
        
            'send back good return code
            bDeleteFile = True
            
        Else
            
            'send back the error
            bDeleteFile = False
            ErrorUpd Err.LastDllError, Err.Description
            
        End If
        
    Else
    
        'whoa...we don't have a connection
        mlngErrorNum = -1
        mstrErrorDesc = "No available connection."
        bDeleteFile = False
        
    End If

End Function

Public Function bSetCurrentDir(ByVal strDirName As String) As Variant
    
    Dim strTempDir As String
    Dim blnRC As Boolean
    
    'clean up any old errors
    ErrorClear
    
    'make sure we have a connection
    If mlngINetConn <> 0 Then
    
        'init the buffer for the returned directory info
        strTempDir = Space$(MAX_PATH)
    
        'get the current directory name
        blnRC = FtpSetCurrentDirectory(mlngINetConn, strDirName)
        
        'how'd we do?
        If blnRC Then
        
            'send back the current directory name
            bSetCurrentDir = True
            
        Else
            
            'send back the error
            bSetCurrentDir = False
            ErrorUpd Err.LastDllError, Err.Description
            
        End If
        
    Else
    
        'whoa...we don't have a connection
        mlngErrorNum = -1
        mstrErrorDesc = "No available connection."
        bSetCurrentDir = False
        
    End If

End Function

Private Sub ErrorClear()
    
    'just clean up old error vars
    mlngErrorNum = 0
    mstrErrorDesc = ""
    
End Sub

Private Sub ErrorUpd(ByVal lngErr As Long, _
    ByVal strErrDesc As String)

    Dim strError As String
    Dim blnRC As Boolean
    Dim lngErrX As Long

    'see if there's more info
    If lngErr = ERROR_INTERNET_EXTENDED_ERROR Then
        
        'get the additional info
        strError = Space$(255)
        blnRC = InternetGetLastResponseInfo(lngErrX, strError, 255)
        
        'did we get the additional info?
        If blnRC Then
            
            'we got something...need to clean it up
            strError = Left(strError, InStr(1, strError, Chr$(0), vbBinaryCompare) - 1)
            
            'update error stuff
            mlngErrorNum = Val(strError)
            mstrErrorDesc = Mid(strError, InStr(strError, CStr(mlngErrorNum)) + Len(CStr(mlngErrorNum)) + 1)
            
        Else
        
            'send back previous error
            mlngErrorNum = lngErr
            mstrErrorDesc = strErrDesc
            
        End If
        
    Else
    
        'update error stuff
        mlngErrorNum = lngErr
        mstrErrorDesc = strErrDesc
        
    End If
    
End Sub
Public Function sGetCurrentDir() As Variant
    
    Dim strTempDir As String
    Dim blnRC As Boolean
    
    'clean up any old errors
    ErrorClear
    
    'make sure we have a connection
    If mlngINetConn <> 0 Then
    
        'init the buffer for the returned directory info
        strTempDir = Space$(MAX_PATH)
    
        'get the current directory name
        blnRC = FtpGetCurrentDirectory(mlngINetConn, strTempDir, MAX_PATH)
        
        'how'd we do?
        If blnRC Then
        
            'we got something...need to clean it up
            strTempDir = Left(strTempDir, InStr(1, strTempDir, Chr$(0), vbBinaryCompare) - 1)

            'send back the current directory name
            sGetCurrentDir = strTempDir
            
        Else
            
            'send back the error
            ErrorUpd Err.LastDllError, Err.Description
            sGetCurrentDir = mlngErrorNum & ": " & mstrErrorDesc
            
        End If
        
    Else
    
        'whoa...we don't have a connection
        sGetCurrentDir = "-1: No available connection."
        
    End If
    
End Function

