VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsItem"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private mstrItemName As String
Private mlngAttributes As Long

Private Const FILE_ATTRIBUTE_READONLY = &H1
Private Const FILE_ATTRIBUTE_HIDDEN = &H2
Private Const FILE_ATTRIBUTE_SYSTEM = &H4
Private Const FILE_ATTRIBUTE_DIRECTORY = &H10
Private Const FILE_ATTRIBUTE_ARCHIVE = &H20
Private Const FILE_ATTRIBUTE_NORMAL = &H80
Private Const FILE_ATTRIBUTE_TEMPORARY = &H100
Private Const FILE_ATTRIBUTE_COMPRESSED = &H800
Private Const FILE_ATTRIBUTE_OFFLINE = &H1000

Friend Property Get Name() As String
    Name = mstrItemName
End Property

Friend Property Let Name(ByVal strName As String)
    mstrItemName = strName
End Property

Friend Property Get Attributes() As Long
    Attributes = mlngAttributes
End Property

Friend Property Let Attributes(ByVal lngAttributes As Long)
    mlngAttributes = lngAttributes
End Property

Friend Property Get ReadOnly() As Boolean
    ReadOnly = (mlngAttributes And FILE_ATTRIBUTE_READONLY) = FILE_ATTRIBUTE_READONLY
End Property

Friend Property Get Hidden() As Boolean
    Hidden = (mlngAttributes And FILE_ATTRIBUTE_HIDDEN) = FILE_ATTRIBUTE_HIDDEN
End Property

Friend Property Get System() As Boolean
    System = (mlngAttributes And FILE_ATTRIBUTE_SYSTEM) = FILE_ATTRIBUTE_SYSTEM
End Property

Friend Property Get Directory() As Boolean
    Directory = (mlngAttributes And FILE_ATTRIBUTE_DIRECTORY) = FILE_ATTRIBUTE_DIRECTORY
End Property

Friend Property Get Archive() As Boolean
    Archive = (mlngAttributes And FILE_ATTRIBUTE_ARCHIVE) = FILE_ATTRIBUTE_ARCHIVE
End Property

Friend Property Get Normal() As Boolean
    Normal = (mlngAttributes And FILE_ATTRIBUTE_NORMAL) = FILE_ATTRIBUTE_NORMAL
End Property

Friend Property Get Temporary() As Boolean
    Temporary = (mlngAttributes And FILE_ATTRIBUTE_TEMPORARY) = FILE_ATTRIBUTE_TEMPORARY
End Property

Friend Property Get Compressed() As Boolean
    Compressed = (mlngAttributes And FILE_ATTRIBUTE_COMPRESSED) = FILE_ATTRIBUTE_COMPRESSED
End Property

Friend Property Get Offline() As Boolean
    Offline = (mlngAttributes And FILE_ATTRIBUTE_OFFLINE) = FILE_ATTRIBUTE_OFFLINE
End Property

